## 2utf 1.04

=== Makefile ===
# Installation:
#  make distclean
#  make config
#  make
#  make install

Package=2UTF
package=2utf

SHELL = /bin/sh

CC      = cc

# Don't use multibyte functions from Linux libc5 - use files from `tcs' instead!
# Uncomment this if your mbtowc() and wctomb() are not broken,
#then make distclean.
#USE_LIBC=yes

# install files with this ownership:
owner=root
group=staff

install_own = -o $(owner) -g $(group)

include Makefile.config
#.include "Makefile.config"

BIN     = 2UTF
BINalias = fromUTF
DEBDIST	= ../$(package)_$(VERSION)_$(ARCHITECTURE).changes \
	../$(package)_$(VERSION)_$(ARCHITECTURE).deb \
	../$(package)_$(VERSION).dsc \
	../$(package)_$(VERSION).tar.gz
DEBIAN	= debian/changelog debian/control.in debian/copyright debian/rules 
DOCS    = TODO copyright changelog BSD_style_license
EXAMPLES = examples/IBM771.gz examples/IBM772.gz examples/LatArCyrHeb.uni.gz \
	examples/Makefile examples/Minicom examples/README \
	examples/linux+utf8.ti examples/procmailrc \
	examples/set_sticky_palette_for_linux-gr+utf8_terminal
# comment this out if you don't want compressed man pages and docs:
GZIPDOCS = yes
MAN1	= $(BIN).1
MAN1alias = $(BINalias).1
MAN1alias2 = toUTF.1
SRCS    = $(BIN).c $(BIN).h utf.c hdr.h plan9.h mimedecode.c
OBJS   = utf.o mimedecode.o
prefix  = /usr/local
var_prefix  = /var/local
# remove trailing /
#prefix := $(prefix:/=)
exec_prefix = $(prefix)
localstatedir = $(var_prefix)/lib
ALIASES = $(localstatedir)/$(BIN).aliases
bindir  = $(exec_prefix)/bin
docsdir  = $(prefix)/doc/$(Package)
examplesdir = $(docsdir)/examples
charmaps_localdatadir  = /usr/local/share/i18n/charmaps
man1dir  = $(prefix)/man/man1
# for terminal initialization script
sbindir  = $(exec_prefix)/sbin
sysconfdir = $(prefix)/etc
term_init_script = examples/set_sticky_palette_for_linux-gr+utf8_terminal
# ~ is not expanded. String must end with \0
CONFIG_PATHNAMES = $(sysconfdir)/$(BIN).config\0/usr/local/etc/$(BIN).config\0/usr/etc/$(BIN).config\0/etc/$(BIN).config\0\0
DEFS    = '-DALIASES="$(ALIASES)"' '-DPATH="$(charmaps_localdatadir)"' \
	 '-DCONFIG_PATHNAMES="$(CONFIG_PATHNAMES)"' '-DVERSION="$(VERSION)"' \
	 $(USE_LIBC_DEF)

# flags for your C compilator:
#OPT = -g3 -O0
OPT = -O2
WARN = -Wall -W -Wconversions -Wbad-function-cast
CFLAGS  = $(OPT) $(WARN) $(DEFS)
LDFLAGS = #none

all:	$(BIN) linux+utf8.ti

config:
	echo \# Generated by \`make config\' >Makefile.config
	set -xe; \
		if [ $(USE_LIBC)_ = yes_ ] \
		|| { [ $(USE_LIBC)_ != no_ ] && [ $(USE_LIBC)x = x ] \
		  && OS=`uname -s` && [ $${OS%%[Ll][Ii][Nn][Uu][Xx]}x = x ] \
		  && z=`ldd \`type $(CC) | { read a b c; echo $$c; }\`` \
		  && [ $${z%%*libc.so.[6789]*}x = x ]; } \
		   then \
			echo USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
			echo '$$(BIN): mimedecode.o' >Makefile.2; \
		   else \
			echo \# USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
			echo '$$(BIN): utf.o mimedecode.o' >>Makefile.2; \
			echo utf.o: hdr.h plan9.h >>Makefile.2; \
		fi >>Makefile.config
	echo VERSION = `{ pwd -P || pwd; } | \
		sed -e 's!.*/\($(Package)\|$(package)\)-!!'` >>Makefile.config
	ARCHITECTURE="`if test -x /usr/bin/dpkg; \
		then dpkg --print-architecture; else uname -m; fi`" \
	&& if [ "$${ARCHITECTURE%%i?86}"y = y ]; then ARCHITECTURE=i386; fi \
	&& echo ARCHITECTURE = "$$ARCHITECTURE" >>Makefile.config 

$(Package)-$(VERSION).lsm lsm:	$(Package).lsm.in
	-rm -f $(package)*.lsm $(Package)*.lsm
	[ $(VERSION)x != x ]
	sed -e 's/$${date}/'`LC_ALL=C date +%d%b%y |tr a-z A-Z`'/g; \
		s/$${version}/$(VERSION)/g'  $< >$(Package)-$(VERSION).lsm
	touch lsm

$(Package)-$(VERSION).spec:	$(Package).spec.in
	-rm -f $(Package)*.spec
	[ $(VERSION)x != x ]
	Summary="`sed -n -e 's/^Description:[[:space:]]*//p' \
						$(Package).lsm.in`" \
	&& Copying="`sed -n -e 's/^Copying-policy:[[:space:]]*//p' \
						$(Package).lsm.in`" \
	&& sed -e 's/$${version}/$(VERSION)/g; s/$${summary}/'"$${Summary}"'/g; \
		 s/$${copying}/'"$${Copying}"/g \
		 $< >tmp
	sed -n -e '1,/^%description/p' tmp >$@
	sed -n -e '/^Description:/,/^[^[:space:]]/!d; /^[[:space:]]/p' \
		$(Package).lsm.in >>$@
	sed -n -e '1,/^%description/!p' tmp >>$@
	rm -f tmp

$(BIN).o: $(BIN).h approx.c

include Makefile.2
#.include Makefile.2

approx.c: approx.c.in0 approx.c.in1 approx.c.in2 approx.c.in3
	echo -n 'char approx2ascii[][5] = { ' >$@
	sed -e 's/"/\\042/g; s/^\(....\)[[:space:]]*$$/\1 x /; s/^.... [^[:space:]][^[:space:]]*[[:space:]]*$$/& \\0/; s/^.... [^[:space:]][^[:space:]]*[[:space:]][[:space:]]*\([^[:space:]][^[:space:]]*\)/"\1",/' approx.c.in[0-3] >>$@ || { rm $@; false; }
	echo '};' >>$@

clean:
	-rm  -R -f *.o *~ *.bak 1 2 t t2 tt tags tmp \#*\# errors* \
		core* linux+utf8.ti \
		a.out approx.c ./stdin ./stdout typescript filelist \
		debian/control debian/tmp debian/files* debian/substvars* \
		$(BIN) $(Package)-*.spec $(Package)-*.lsm lsm

debdist $(DEBDIST):	examples $(DEBIAN) $(DOCS) $(MAN1) $(SRCS)
	[ $(VERSION)x != x ]
	test -r $$HOME/.pgp/secring.pgp
	dpkg-buildpackage
	$(MAKE) config

dist tar: $(DEBIAN) distclean examples $(DOCS) $(MAN1) $(SRCS) $(Package)-$(VERSION).lsm $(Package)-$(VERSION).spec
	[ $(VERSION)x != x ]
	-rm -f -R /tmp/$(Package)-$(VERSION)/
	mkdir /tmp/$(Package)-$(VERSION)
	tar -cf- ./ | { cd /tmp/$(Package)-$(VERSION) && tar -xpf -; }
	cd ../ && xPWD="`pwd`" \
		&& cd /tmp/ && tar -cvzf "$$xPWD"/$(Package)-$(VERSION).tar.gz \
				$(Package)-$(VERSION)/
	-rm -f -R /tmp/$(Package)-$(VERSION)/
	$(MAKE) config

distclean: clean
	-rm -f ../$(package)_$(VERSION)_$(ARCHITECTURE).deb
	echo make_from_scratch: distclean config myself >Makefile.config 
	echo >Makefile.2

disttest:	$(DEBDIST)
	cp $(addprefix ../$(package)_$(VERSION).,dsc tar.gz) /tmp/
	cd /tmp && tar -xvzf $(package)_$(VERSION).tar.gz
	cd /tmp/$(package)-$(VERSION) && make \
		&& make install test uninstall
	rm -R -f /tmp/$(package)-$(VERSION)
	cd /tmp && dpkg-source -x $(package)_$(VERSION).dsc
	cd /tmp/$(package)-$(VERSION) && \
		dpkg-buildpackage -B
	dpkg --contents /tmp/$(package)_$(VERSION)_$(ARCHITECTURE).deb
	-rpm --erase --allmatches $(Package)
	dpkg --install  /tmp/$(package)_$(VERSION)_$(ARCHITECTURE).deb
	cd /tmp/$(package)-$(VERSION) && rm $(DEBDIST)
	rm -R -f /tmp/$(package)-$(VERSION)

examples:
	if test -d ../linux-lt-current; then cd examples && make all; fi

install:	all $(DOCS) $(MAN1) $(EXAMPLES) $(term_init_script)
	install -d $(install_own) -m 2775 $(bindir)
	install -s $(install_own) -m 775  $(BIN)      $(bindir)
	cd $(bindir) && ln -f -s $(BIN) $(BINalias)
	install -d $(install_own) -m 2775 $(docsdir)
	install    $(install_own) -m 664  $(DOCS)     $(docsdir)
	install -d $(install_own) -m 2775 $(examplesdir)
	install    $(install_own) -m 664  $(EXAMPLES) $(examplesdir)
	install -d $(install_own) -m 2775 $(man1dir)
	install -d $(install_own) -m 2775	$(charmaps_localdatadir)
	install    $(install_own) -m 664  $(MAN1)     $(man1dir)
	install -d $(install_own) -m 2775 $(sysconfdir)
	cmp -s $(sysconfdir)/$(BIN).config  $(BIN).config; exit_code=$$?; \
	if [ _$$exit_code != _0 ]; then \
		if [ _$$exit_code = _1 ]; then suffix=.new; fi; \
		install    $(install_own) -m 664 \
			$(BIN).config $(sysconfdir)/$(BIN).config$$suffix; \
	fi
	if [ $(GZIPDOCS) = yes ]; \
	then \
		gzip --best --force --verbose \
			$(docsdir)/changelog $(man1dir)/$(MAN1); \
		cd $(man1dir) && ln -f -s $(MAN1).gz $(MAN1alias).gz \
		&& ln -f -s $(MAN1).gz $(MAN1alias2).gz; \
	else \
		cd $(man1dir) && ln -f -s $(MAN1) $(MAN1alias) \
		&& ln -f -s $(MAN1) $(MAN1alias2); \
	fi
	install -d $(install_own) -m 2775 `dirname $(ALIASES)`
	# check if this is install in temporary directory:
	set -xe; \
	if prefix=$(prefix) && \
			[ $${prefix%%/*}x != x -o $(tmpdir_install)_ = yes_ ]; \
	then \
		dd bs=11000 count=1 </dev/zero >$(ALIASES); \
		chown $(owner).$(group) $(ALIASES); chmod 664 $(ALIASES); \
		if [ $${prefix##debian*}y != y ]; \
		then \
		    TERMINFO=; tic linux+utf8.ti; \
		    install -d $(install_own) -m 2775 \
			    $(prefix)/share/terminfo/l/; \
		    cp /usr/share/terminfo/l/linux+utf8 \
			    /usr/share/terminfo/l/linux-gr+utf8 \
				    $(prefix)/share/terminfo/l/; \
		fi; \
	else \
		$(bindir)/$(BIN) --create-aliases; \
		tic linux+utf8.ti; \
	fi; \
	if [ $${prefix%%debian*}y != y ]; \
	then \
		install -d $(install_own) -m 2775 $(sbindir); \
		install $(install_own) -m 775 $(term_init_script) $(sbindir); \
	fi
	# you can specify directory for tic, but that doesn't work :-(

linux+utf8.ti:	examples/linux+utf8.ti
	sed -e 's!/usr/sbin!$(sbindir)!' $< >$@

myself:
	$(MAKE) all

realclean: distclean
	-rm -f $(DEBDIST)

rpm:		tar $(Package)-$(VERSION).spec
		cp ../$(Package)-$(VERSION).tar.gz /usr/src/redhat/SOURCES
		rpm -v -ba $(Package)-$(VERSION).spec

rpmi:
		rpm -vv -bi --short-circuit $(Package)-$(VERSION).spec

rpmsign:
	test -r $$HOME/.pgp/secring.pgp
	rpm -vv --resign \
		/usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
		/usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.$(ARCHITECTURE).rpm

rpmdist:	rpm rpmsign

tags:	$(SRCS)
	ctags *.[ch]

test check:
	$(bindir)/$(BINalias) --help
	$(bindir)/$(BIN) --show-charmap --verbose 88591
	@echo -n "Press <enter> ... "
	@read a

uninstall:
	-rm -f $(ALIASES) $(bindir)/$(BIN) $(bindir)/$(BINalias)
	cd $(man1dir) \
		&& for f in $(MAN1) $(MAN1alias) $(MAN1alias2); \
			do rm -f  $$f $$f.gz; done
	cd $(docsdir) \
		&& for f in $(DOCS); do rm -f $$f $$f.gz; done
	cd $(examplesdir) \
		&& for f in $(EXAMPLES); \
			do rm -f $${f##*/} $${f##*/}.gz; done
	-rmdir $(examplesdir)
	-rmdir $(docsdir)

UPHOST=sunsite.unc.edu
upload: #dist debdist ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm
	[ $(VERSION)x != x ]
	[ "`rpm --checksig \
		/usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
		/usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.$(ARCHITECTURE).rpm \
	| grep -c 'pgp md5 OK$$'`" = 2 ]
	set -x; xPWD=`pwd` && echo -e open -r -d 10 ftp.redhat.com\\n \
	   cd /pub/Incoming\\n \
	   mput /usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
	    /usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.rpm\\n \
	   dir $(Package)-$(VERSION)-0.src.rpm $(Package)-$(VERSION)-0.i386.rpm\\n \
	   redir \>$$xPWD/../$(Package)-$(VERSION).ftp.redhat.com\\n \
	| ncftp
	set -x; xPWD=`pwd` && echo -e open -r -d 10 $(UPHOST)\\n \
	   cd /incoming/Linux\\n \
	   lcd $$xPWD\\n \
	   mput ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm\\n \
	   dir $(Package)*\\n \
	   redir $(Package)* \>../$(Package)-$(VERSION).$(UPHOST)\\n \
	| ncftp
	dupload --to erlangen ../$(package)_$(VERSION)_$(ARCHITECTURE).changes
	echo -ne \\a
	sleep 1s
	echo -ne \\a

# vi: set noexpandtab:

=== examples/Makefile ===
# (c) Ricardas Cepas <rch@pub.osf.lt>. Copying policy: BSD or GNU GPL V2.
FONTS512 = LatArCyrHeb.uni

all:
	PWD="`pwd -P`" && cd ../../linux-lt-current/ \
		&& cp --verb --force --update \
			LatArCyrHeb.uni linux+utf8.ti \
			set_sticky_palette_for_linux-gr+utf8_terminal "$$PWD" \
		&& cp --verb --force --update \
			BSD_style_license "$$PWD"/..
	gzip --best --force LatArCyrHeb.uni 

install:
#	-kbd_share_dir=/usr/share; \
#	   install --owner=root --group=staff --mode=ug=rw,o=r \
#		$(filter %.psf, $(FONTS) $(FONTS2) $(FONTS512)) \
#				 $$kbd_share_dir/consolefonts/
#	install --owner=root --group=staff --mode=ug=rw,o=r \
#		$(filter-out %.psf, $(FONTS) $(FONTS2) $(FONTS512)) \
#				 $$kbd_share_dir/consoletrans/
	
	@echo Installing terminfo entries...
	tic linux+utf8.ti
	install --owner=root --group=root --mode=u=rwx,go=rx \
		set_sticky_palette_for_linux-gr+utf8_terminal* /usr/sbin/

.PHONY: all install
# vi: set noexpandtab:

=== debian/control ===
Source: 2utf
Section: text
Priority: optional
Maintainer: Ricardas Cepas <rch@debian.org>
Standards-Version: 2.3.0.1

Package: 2utf
Architecture: any
Depends: ${shlibs:Depends}
Recommends: locales | wg15-locale, man-db (>= 2.3.10-37)
Suggests: tcs, kbd (>= 0.95)
Description: Translates char-sets and decodes MIME.
 Filter for char-set translation to and from Unicode.
 Gets char-set definitions from WG15 locales char-maps or similiar tables.
 Can decode nested multi-part MIME messages and invoke external filters.
 Can display char-maps and current console font.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

# There used to be `source' and `diff' targets in this file, and many
# packages also had `changes' and `dist' targets.  These functions
# have been taken over by dpkg-source, dpkg-genchanges and
# dpkg-buildpackage in a package-independent way, and so these targets
# are obsolete.

Package=2UTF
package=2utf

SHELL = /bin/sh

DEBDIST	= ../$(package)_$(VERSION)_$(ARCHITECTURE).changes \
	../$(package)_$(VERSION)_$(ARCHITECTURE).deb \
	../$(package)_$(VERSION).dsc \
	../$(package)_$(VERSION).tar.gz
DEBIAN	= debian/changelog debian/control.in debian/copyright debian/rules 

build:	checkdir
	$(MAKE) config
	$(MAKE) USE_LIBC=yes GZIPDOCS=yes prefix=/usr sysconfdir=/etc \
					var_prefix=/var

clean:
	$(MAKE) distclean
	$(MAKE) config
	$(MAKE) lsm
	debian/rules debian/control

binary-indep:	checkroot build
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot debian/control build $(DEBIAN)
	-rm -f -R debian/tmp
	install --directory debian/tmp/DEBIAN # debian/tmp/usr/lib/menu
	$(MAKE) GZIPDOCS=yes prefix=debian/tmp/usr sysconfdir=debian/tmp/etc \
		var_prefix=debian/tmp/var \
		docsdir=debian/tmp/usr/doc/$(package) \
		tmpdir_install=yes install
	cd debian && install --owner=root --group=root --mode=u=rwx,go=rx \
			 conffiles postinst postrm tmp/DEBIAN/
#	install --owner=root --group=root --mode=u=rw,go=r \
#			 menu debian/tmp/usr/lib/menu/$(package)
	dpkg-shlibdeps 2UTF -O >debian/substvars
	chown root.root debian/substvars
	dpkg-gencontrol
	chown -R root.root	debian/tmp
#	chown -R root.staff	debian/tmp/usr/local
	chmod -R g-ws		debian/tmp
#	chmod -R g+ws		debian/tmp/usr/local
	dpkg --build debian/tmp ..

# Below here is fairly generic really

binary:		binary-indep binary-arch

checkroot:	checkdir
	test root = "`whoami`"

checkdir:	debian/rules
#	[ $(basename $(VERSION)) -le 3 \
#		-a  $(subst .,,$(suffix $(VERSION))) -le 99 \
#		-a  -f 2UTF.c -a -f debian/rules ]

debian/control:	debian/control.in $(Package).lsm.in
	cp -f $< $@
	sed -n -e '/^Description:/,/^[^[:space:]]/p' \
		$(Package).lsm.in |sed -e '$$d' >>$@

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

.PHONY: all binary binary-arch binary-indep check checkdir checkroot \
	clean diff dist distclean disttest install realclean source tags tar \
	test uninstall upload
	

# vi: set noexpandtab:

## 2utf 1.10

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 #  make config
 #  make
 #  make install
+# (c) Ricardas Cepas <rch@pub.osf.lt>. Copying policy: Berkeley style
 
 Package=2UTF
 package=2utf
@@ -18,9 +19,16 @@
 
 # install files with this ownership:
 owner=root
-group=staff
+# Group is defined by `make config' (staff wheel bin root).
+# You can override it at command line:
+#   make ... group=staff
 
 install_own = -o $(owner) -g $(group)
+INSTALL_DATA = install -c	$(install_own) -m 664
+INSTALL_MAN = $(INSTALL_DATA)
+INSTALL_PROGRAM = install -c -s $(install_own) -m 775
+INSTALL_SCRIPT =  install -c $(install_own) -m 775
+MKDIR = install -d $(install_own) -m 2775
 
 include Makefile.config
 #.include "Makefile.config"
@@ -43,16 +51,17 @@
 MAN1alias = $(BINalias).1
 MAN1alias2 = toUTF.1
 SRCS    = $(BIN).c $(BIN).h utf.c hdr.h plan9.h mimedecode.c
-OBJS   = utf.o mimedecode.o
-prefix  = /usr/local
-var_prefix  = /var/local
+OBJS   = $(BIN).o mimedecode.o
+PREFIX  = /usr/local
+prefix  = ${PREFIX}
+var_prefix  = /var
 # remove trailing /
 #prefix := $(prefix:/=)
 exec_prefix = $(prefix)
 localstatedir = $(var_prefix)/lib
 ALIASES = $(localstatedir)/$(BIN).aliases
 bindir  = $(exec_prefix)/bin
-docsdir  = $(prefix)/doc/$(Package)
+docsdir  = $(prefix)/share/doc/$(Package)
 examplesdir = $(docsdir)/examples
 charmaps_localdatadir  = /usr/local/share/i18n/charmaps
 man1dir  = $(prefix)/man/man1
@@ -85,24 +94,36 @@
 		  && [ $${z%%*libc.so.[6789]*}x = x ]; } \
 		   then \
 			echo USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
-			echo '$$(BIN): mimedecode.o' >Makefile.2; \
+			echo OptionalObjectFiles = ; \
 		   else \
 			echo \# USE_LIBC_DEF = \'-DUSE_LIBC=yes\'; \
-			echo '$$(BIN): utf.o mimedecode.o' >>Makefile.2; \
-			echo utf.o: hdr.h plan9.h >>Makefile.2; \
+			echo OptionalObjectFiles = utf.o; \
 		fi >>Makefile.config
+	set -xe; \
+		for group in staff wheel bin root; \
+		do if install -d -g $$group ./tstdir; \
+		   then \
+			echo group=$$group >>Makefile.config; \
+			rmdir ./tstdir; \
+			break; \
+		   fi; \
+		done;
 	echo VERSION = `{ pwd -P || pwd; } | \
-		sed -e 's!.*/\($(Package)\|$(package)\)-!!'` >>Makefile.config
+		sed -e 's!.*/$(Package)-!!;s!.*$(package)-!!'` >>Makefile.config
 	ARCHITECTURE="`if test -x /usr/bin/dpkg; \
 		then dpkg --print-architecture; else uname -m; fi`" \
 	&& if [ "$${ARCHITECTURE%%i?86}"y = y ]; then ARCHITECTURE=i386; fi \
 	&& echo ARCHITECTURE = "$$ARCHITECTURE" >>Makefile.config 
 
+FreeBSD_port/$(Package)/Makefile:	FreeBSD_port/$(Package)/Makefile.in
+	[ $(VERSION)x != x ]
+	sed -e 's/$${version}/$(VERSION)/g'  $? >FreeBSD_port/$(Package)/Makefile
+
 $(Package)-$(VERSION).lsm lsm:	$(Package).lsm.in
 	-rm -f $(package)*.lsm $(Package)*.lsm
 	[ $(VERSION)x != x ]
 	sed -e 's/$${date}/'`LC_ALL=C date +%d%b%y |tr a-z A-Z`'/g; \
-		s/$${version}/$(VERSION)/g'  $< >$(Package)-$(VERSION).lsm
+		s/$${version}/$(VERSION)/g'  $? >$(Package)-$(VERSION).lsm
 	touch lsm
 
 $(Package)-$(VERSION).spec:	$(Package).spec.in
@@ -114,7 +135,7 @@
 						$(Package).lsm.in`" \
 	&& sed -e 's/$${version}/$(VERSION)/g; s/$${summary}/'"$${Summary}"'/g; \
 		 s/$${copying}/'"$${Copying}"/g \
-		 $< >tmp
+		 $? >tmp
 	sed -n -e '1,/^%description/p' tmp >$@
 	sed -n -e '/^Description:/,/^[^[:space:]]/!d; /^[[:space:]]/p' \
 		$(Package).lsm.in >>$@
@@ -123,8 +144,8 @@
 
 $(BIN).o: $(BIN).h approx.c
 
-include Makefile.2
-#.include Makefile.2
+$(BIN): $(OBJS) $(OptionalObjectFiles)
+	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(OBJS) $(OptionalObjectFiles) -o $@
 
 approx.c: approx.c.in0 approx.c.in1 approx.c.in2 approx.c.in3
 	echo -n 'char approx2ascii[][5] = { ' >$@
@@ -132,11 +153,13 @@
 	echo '};' >>$@
 
 clean:
-	-rm  -R -f *.o *~ *.bak 1 2 t t2 tt tags tmp \#*\# errors* \
+	-rm  -R -f *.o *~ *.bak 1 2 t t2 tt tags tmp tst* \#*\# errors* \
 		core* linux+utf8.ti \
 		a.out approx.c ./stdin ./stdout typescript filelist \
 		debian/control debian/tmp debian/files* debian/substvars* \
-		$(BIN) $(Package)-*.spec $(Package)-*.lsm lsm
+		$(BIN) $(Package)-*.spec $(Package)-*.lsm lsm \
+		FreeBSD_port/$(Package)/work \
+		FreeBSD_port/$(Package)/Makefile
 
 debdist $(DEBDIST):	examples $(DEBIAN) $(DOCS) $(MAN1) $(SRCS)
 	[ $(VERSION)x != x ]
@@ -144,7 +167,7 @@
 	dpkg-buildpackage
 	$(MAKE) config
 
-dist tar: $(DEBIAN) distclean examples $(DOCS) $(MAN1) $(SRCS) $(Package)-$(VERSION).lsm $(Package)-$(VERSION).spec
+dist tar: $(DEBIAN) distclean examples $(DOCS) $(MAN1) $(SRCS) $(Package)-$(VERSION).lsm $(Package)-$(VERSION).spec FreeBSD_port/$(Package)/Makefile
 	[ $(VERSION)x != x ]
 	-rm -f -R /tmp/$(Package)-$(VERSION)/
 	mkdir /tmp/$(Package)-$(VERSION)
@@ -156,15 +179,16 @@
 	$(MAKE) config
 
 distclean: clean
-	-rm -f ../$(package)_$(VERSION)_$(ARCHITECTURE).deb
+	#! -rm -f ../$(package)_$(VERSION)_$(ARCHITECTURE).deb
 	echo make_from_scratch: distclean config myself >Makefile.config 
-	echo >Makefile.2
 
 disttest:	$(DEBDIST)
+	rm -R -f /tmp/$(package)-$(VERSION)
 	cp $(addprefix ../$(package)_$(VERSION).,dsc tar.gz) /tmp/
 	cd /tmp && tar -xvzf $(package)_$(VERSION).tar.gz
-	cd /tmp/$(package)-$(VERSION) && make \
-		&& make install test uninstall
+	make rpm
+	rpm --install --force --nodeps /usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-0.$(ARCHITECTURE).rpm
+	rpm -qisv $(Package)
 	rm -R -f /tmp/$(package)-$(VERSION)
 	cd /tmp && dpkg-source -x $(package)_$(VERSION).dsc
 	cd /tmp/$(package)-$(VERSION) && \
@@ -174,26 +198,33 @@
 	dpkg --install  /tmp/$(package)_$(VERSION)_$(ARCHITECTURE).deb
 	cd /tmp/$(package)-$(VERSION) && rm $(DEBDIST)
 	rm -R -f /tmp/$(package)-$(VERSION)
-
-examples:
+	dpkg --purge $(package)
+	cp $(addprefix ../$(package)_$(VERSION).,dsc tar.gz) /tmp/
+	cd /tmp && tar -xvzf $(package)_$(VERSION).tar.gz
+	cd /tmp/$(package)-$(VERSION) && pmake \
+		&& pmake install test uninstall && make install SHELL=/bin/ash
+	rm -R -f /tmp/$(package)-$(VERSION)
+	$(MAKE) tar
+
+Examples:
 	if test -d ../linux-lt-current; then cd examples && make all; fi
 
 install:	all $(DOCS) $(MAN1) $(EXAMPLES) $(term_init_script)
-	install -d $(install_own) -m 2775 $(bindir)
-	install -s $(install_own) -m 775  $(BIN)      $(bindir)
+	test -e $(bindir) || $(MKDIR) $(bindir)
+	$(INSTALL_PROGRAM)  $(BIN)      $(bindir)
 	cd $(bindir) && ln -f -s $(BIN) $(BINalias)
-	install -d $(install_own) -m 2775 $(docsdir)
-	install    $(install_own) -m 664  $(DOCS)     $(docsdir)
-	install -d $(install_own) -m 2775 $(examplesdir)
-	install    $(install_own) -m 664  $(EXAMPLES) $(examplesdir)
-	install -d $(install_own) -m 2775 $(man1dir)
-	install -d $(install_own) -m 2775	$(charmaps_localdatadir)
-	install    $(install_own) -m 664  $(MAN1)     $(man1dir)
-	install -d $(install_own) -m 2775 $(sysconfdir)
+	test -e $(docsdir) || $(MKDIR) $(docsdir)
+	$(INSTALL_MAN)  $(DOCS)     $(docsdir)
+	test -e $(examplesdir) || $(MKDIR) $(examplesdir)
+	$(INSTALL_MAN)  $(EXAMPLES) $(examplesdir)
+	test -e $(man1dir) || $(MKDIR) $(man1dir)
+	$(INSTALL_MAN)  $(MAN1)     $(man1dir)
+	test -e $(sysconfdir) || $(MKDIR) $(sysconfdir)
+	set +o errexit; \
 	cmp -s $(sysconfdir)/$(BIN).config  $(BIN).config; exit_code=$$?; \
 	if [ _$$exit_code != _0 ]; then \
 		if [ _$$exit_code = _1 ]; then suffix=.new; fi; \
-		install    $(install_own) -m 664 \
+		$(INSTALL_DATA) \
 			$(BIN).config $(sysconfdir)/$(BIN).config$$suffix; \
 	fi
 	if [ $(GZIPDOCS) = yes ]; \
@@ -206,7 +237,7 @@
 		cd $(man1dir) && ln -f -s $(MAN1) $(MAN1alias) \
 		&& ln -f -s $(MAN1) $(MAN1alias2); \
 	fi
-	install -d $(install_own) -m 2775 `dirname $(ALIASES)`
+	test -e `dirname $(ALIASES)` || $(MKDIR) `dirname $(ALIASES)`
 	# check if this is install in temporary directory:
 	set -xe; \
 	if prefix=$(prefix) && \
@@ -214,31 +245,56 @@
 	then \
 		dd bs=11000 count=1 </dev/zero >$(ALIASES); \
 		chown $(owner).$(group) $(ALIASES); chmod 664 $(ALIASES); \
-		if [ $${prefix##debian*}y != y ]; \
+		if [ $${prefix##debian*}y != y ] ; \
 		then \
+		 if ! tic -V 2>&1 |grep -q tconv; then \
 		    TERMINFO=; tic linux+utf8.ti; \
-		    install -d $(install_own) -m 2775 \
+		    test -e $(prefix)/share/terminfo/l/ || $(MKDIR) \
 			    $(prefix)/share/terminfo/l/; \
 		    cp /usr/share/terminfo/l/linux+utf8 \
 			    /usr/share/terminfo/l/linux-gr+utf8 \
+			    /usr/share/terminfo/l/linux+k \
 				    $(prefix)/share/terminfo/l/; \
+		 fi; \
 		fi; \
 	else \
-		$(bindir)/$(BIN) --create-aliases; \
-		tic linux+utf8.ti; \
+		test -e $(charmaps_localdatadir) \
+			|| $(MKDIR) $(charmaps_localdatadir); \
+		if ! tic -V 2>&1 |grep -q tconv; \
+		then tic linux+utf8.ti || echo Can\'t compile terminfo source ; \
+		fi; \
+		$(bindir)/$(BIN) --create-aliases || : ; \
 	fi; \
 	if [ $${prefix%%debian*}y != y ]; \
 	then \
-		install -d $(install_own) -m 2775 $(sbindir); \
-		install $(install_own) -m 775 $(term_init_script) $(sbindir); \
+		test -e $(sbindir) || $(MKDIR) $(sbindir); \
+		$(INSTALL_SCRIPT) $(term_init_script) $(sbindir); \
 	fi
 	# you can specify directory for tic, but that doesn't work :-(
 
 linux+utf8.ti:	examples/linux+utf8.ti
-	sed -e 's!/usr/sbin!$(sbindir)!' $< >$@
+	sed -e 's!/usr/sbin!$(sbindir)!' $? >$@
 
 myself:
 	$(MAKE) all
+
+port:
+	sed -n -e 's/^Description:[[:space:]]*//p' $(Package).lsm.in \
+		> FreeBSD_port/$(Package)/pkg/COMMENT
+	{ sed -n -e '/^Description:/,/^[^[:space:]]/!d; /^[[:space:]]/p' \
+		$(Package).lsm.in |grep -v 'console font'; echo; \
+		echo '- Ricardas Cepas <rch@WriteMe.Com>'; } \
+		> FreeBSD_port/$(Package)/pkg/DESCR
+	cd FreeBSD_port/$(Package)/ # && make makesum
+	cd /tmp/ && rm -rf $(Package)
+	cd FreeBSD_port/$(Package)/work/$(Package)-$(VERSION) \
+		&& make group=wheel prefix=/tmp/$(Package) \
+			examplesdir=/tmp/$(Package)/share/examples/$(Package) install
+	{ find /tmp/$(Package) -type f -or -type l \
+          |sed -e 's!^'/tmp/$(Package)/'!!'; \
+	  echo @dirrm share/examples/$(Package); \
+	  echo @dirrm share/doc/$(Package); \
+	} > FreeBSD_port/$(Package)/pkg/PLIST
 
 realclean: distclean
 	-rm -f $(DEBDIST)
@@ -264,8 +320,7 @@
 test check:
 	$(bindir)/$(BINalias) --help
 	$(bindir)/$(BIN) --show-charmap --verbose 88591
-	@echo -n "Press <enter> ... "
-	@read a
+	@echo -n "Press <enter> ... "; read a
 
 uninstall:
 	-rm -f $(ALIASES) $(bindir)/$(BIN) $(bindir)/$(BINalias)
@@ -280,31 +335,8 @@
 	-rmdir $(examplesdir)
 	-rmdir $(docsdir)
 
-UPHOST=sunsite.unc.edu
-upload: #dist debdist ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm
+upload: upload_main #dist debdist ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm
 	[ $(VERSION)x != x ]
 	[ "`rpm --checksig \
 		/usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
 		/usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.$(ARCHITECTURE).rpm \
-	| grep -c 'pgp md5 OK$$'`" = 2 ]
-	set -x; xPWD=`pwd` && echo -e open -r -d 10 ftp.redhat.com\\n \
-	   cd /pub/Incoming\\n \
-	   mput /usr/src/redhat/SRPMS/$(Package)-$(VERSION)-*.src.rpm \
-	    /usr/src/redhat/RPMS/$(ARCHITECTURE)/$(Package)-$(VERSION)-*.rpm\\n \
-	   dir $(Package)-$(VERSION)-0.src.rpm $(Package)-$(VERSION)-0.i386.rpm\\n \
-	   redir \>$$xPWD/../$(Package)-$(VERSION).ftp.redhat.com\\n \
-	| ncftp
-	set -x; xPWD=`pwd` && echo -e open -r -d 10 $(UPHOST)\\n \
-	   cd /incoming/Linux\\n \
-	   lcd $$xPWD\\n \
-	   mput ../$(Package)-$(VERSION).tar.gz $(Package)-$(VERSION).lsm\\n \
-	   dir $(Package)*\\n \
-	   redir $(Package)* \>../$(Package)-$(VERSION).$(UPHOST)\\n \
-	| ncftp
-	dupload --to erlangen ../$(package)_$(VERSION)_$(ARCHITECTURE).changes
-	echo -ne \\a
-	sleep 1s
-	echo -ne \\a
-
-# vi: set noexpandtab:
-

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: 2utf
 Section: text
 Priority: optional
-Maintainer: Ricardas Cepas <rch@debian.org>
+Maintainer: Ricardas Cepas <rch@WriteMe.Com>
 Standards-Version: 2.3.0.1
 
 Package: 2utf
 Architecture: any
 Depends: ${shlibs:Depends}
 Recommends: locales | wg15-locale, man-db (>= 2.3.10-37)
-Suggests: tcs, kbd (>= 0.95)
+Suggests: tcs, kbd (>= 0.95) | console-utilities
 Description: Translates char-sets and decodes MIME.
  Filter for char-set translation to and from Unicode.
  Gets char-set definitions from WG15 locales char-maps or similiar tables.
